/******************************** Tabela ENCARGO: Cadastro de Produtos ***************************/
/* Descrio: A trigger insere registros na tabela LOGOPERA a partir de alteraes nas colunas: */
/*            CDCTBLENTREN, CDCTBLSAIDEN da tabela ENCARGO                                     */
/* Objetivo: Gerar um log que vai registrar na tabela Geral de Logs de Operaes as alteraes*/
/*        nos campos da tabela Produto listados  seguir:                                    */
/*            Conta contabil: CDCTBLENTREN                                                  */
/********Conta contabil saida: CDCTBLSAIDEN ************************************************/


IF EXISTS (SELECT * FROM SYSOBJECTS O, SYSUSERS U
           WHERE O.NAME = 'LOG_GER_ENCARGO'   AND
                 TYPE   = 'TR'                AND
                 U.UID  = O.UID               AND
                 U.NAME = USER)
DROP TRIGGER LOG_GER_ENCARGO
GO


CREATE TRIGGER LOG_GER_ENCARGO
ON ENCARGO
FOR DELETE, INSERT, UPDATE
AS
   DECLARE @V_DSREMOTEADDR       VARCHAR(15);
   DECLARE @V_DSREMOTEHOST       VARCHAR(15);
   DECLARE @V_DSSERVERRDM        VARCHAR(20);
   DECLARE @V_DSSERVMETHOD       VARCHAR(30);
   DECLARE @V_DSREMOTEOPER       VARCHAR(12);
   DECLARE @V_DESC               VARCHAR(500);
   DECLARE @V_ITPESQ             VARCHAR(40);
   DECLARE @V_NMOPERADOR         VARCHAR(40);
   DECLARE @V_IDTIPOOPER         VARCHAR(1);

/*VARIVEIS DO CURSOR C_CURSOR*/

   DECLARE @V_ID_COMANDO         VARCHAR(1);
   DECLARE @V_OLD_CDENCARGO      VARCHAR(2);
   DECLARE @V_OLD_CDENCARGONFE   VARCHAR(2);
   DECLARE @V_OLD_IDENCARGO      VARCHAR(1);
   DECLARE @V_OLD_CDCTBLENTREN   VARCHAR(20);
   DECLARE @V_OLD_CDCTBLSAIDEN   VARCHAR(20);

   DECLARE @V_NEW_CDENCARGO      VARCHAR(2);
   DECLARE @V_NEW_CDENCARGONFE   VARCHAR(2);
   DECLARE @V_NEW_IDENCARGO      VARCHAR(1);
   DECLARE @V_NEW_CDCTBLENTREN   VARCHAR(20);
   DECLARE @V_NEW_CDCTBLSAIDEN   VARCHAR(20);

BEGIN
/* IDTIPOOPER - '1' - Incluso, '2' - Alterao, '3' - Excluso*/
   SET @V_DESC       = '';
   SET @V_ITPESQ     = '';
   SET @V_NMOPERADOR = '';
   SET @V_IDTIPOOPER = '';
   EXEC NMUSUARIO  @V_NMOPERADOR;
   EXEC WEBTUNNING @V_DSREMOTEADDR,
                   @V_DSREMOTEHOST,
                   @V_DSSERVERRDM,
                   @V_DSSERVMETHOD,
                   @V_DSREMOTEOPER;

   DECLARE C_CURSOR CURSOR FOR
      SELECT
         'D' IDCOMANDO,
         CDENCARGO,
         CDENCARGONFE,
         IDENCARGO,
         CDCTBLENTREN,
         CDCTBLSAIDEN,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL
      FROM
         DELETED
      WHERE
         CDENCARGO NOT IN (SELECT CDENCARGO FROM INSERTED)

      UNION ALL
      SELECT
         'U' IDCOMANDO,
         DELETED.CDENCARGO,
         DELETED.CDENCARGONFE,
         DELETED.IDENCARGO,
         DELETED.CDCTBLENTREN,
         DELETED.CDCTBLSAIDEN,
         INSERTED.CDENCARGO,
         INSERTED.CDENCARGONFE,
         INSERTED.IDENCARGO,
         INSERTED.CDCTBLENTREN,
         INSERTED.CDCTBLSAIDEN
      FROM
         INSERTED,
         DELETED
      WHERE
         DELETED.CDENCARGO = INSERTED.CDENCARGO

      UNION ALL
      SELECT
         'I' IDCOMANDO,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         CDENCARGO,
         CDENCARGONFE,
         IDENCARGO,
         CDCTBLENTREN,
         CDCTBLSAIDEN
      FROM
         INSERTED
      WHERE
         CDENCARGO NOT IN (SELECT CDENCARGO FROM DELETED);

      OPEN C_CURSOR;
      FETCH NEXT FROM C_CURSOR INTO @V_ID_COMANDO,
                                    @V_OLD_CDENCARGO,
                                    @V_OLD_CDENCARGONFE,
                                    @V_OLD_IDENCARGO,
                                    @V_OLD_CDCTBLENTREN,
                                    @V_OLD_CDCTBLSAIDEN,
                                    @V_NEW_CDENCARGO,
                                    @V_NEW_CDENCARGONFE,
                                    @V_NEW_IDENCARGO,
                                    @V_NEW_CDCTBLENTREN,
                                    @V_NEW_CDCTBLSAIDEN;



   WHILE (@@FETCH_STATUS = 0) BEGIN
      IF @V_ID_COMANDO = 'D'/*DELETING*/ BEGIN
         SET @V_IDTIPOOPER   = '3';
         SET @V_ITPESQ       = @V_OLD_CDENCARGO;
         SET @V_DESC         = 'ContaCtblEnt= '       + '' + ISNULL(@V_OLD_CDCTBLENTREN,'')+' '+
                               'ContaCtblSaid= '  + '' + ISNULL(@V_OLD_CDCTBLSAIDEN,'')+ ' '+
                               'CdEncargoNFE= ' + '' + ISNULL(@V_OLD_CDENCARGONFE, '');
         IF NOT @V_OLD_IDENCARGO IS NULL BEGIN
            SET @V_DESC = @V_DESC + ' idencargo= ' + @V_OLD_IDENCARGO;
         END;
      END
      ELSE BEGIN
         IF @V_ID_COMANDO = 'U'/*UPDATING*/ BEGIN
            IF (@V_OLD_IDENCARGO   <> @V_NEW_IDENCARGO)        OR
               (ISNULL(@V_OLD_CDCTBLENTREN, '!')  <> ISNULL(@V_NEW_CDCTBLENTREN, '!'))  OR
               (ISNULL(@V_OLD_CDCTBLSAIDEN, '!')  <> ISNULL(@V_NEW_CDCTBLSAIDEN, '!'))  OR
               (ISNULL(@V_OLD_CDENCARGONFE, '!')  <> ISNULL(@V_OLD_CDENCARGONFE, '!'))  BEGIN
               SET @V_DESC   = 'ContaCtblEnt= '       + '' + ISNULL(@V_NEW_CDCTBLENTREN,'')+' '+
                               'ContaCtblSaid= '  + '' + ISNULL(@V_NEW_CDCTBLSAIDEN,'')+' '+
                               'CdEncargoNFE= ' + '' + ISNULL(@V_NEW_CDENCARGONFE, '');
               SET @V_ITPESQ     = @V_NEW_CDENCARGO;
               SET @V_IDTIPOOPER = '2';
            END;
         END
         ELSE BEGIN
            SET @V_IDTIPOOPER   = '1';
            SET @V_ITPESQ       = @V_NEW_CDENCARGO;
            SET @V_DESC         = 'ContaCtblEnt= '   + '' + ISNULL(@V_NEW_CDCTBLENTREN,'')+' '+
                                  'ContaCtblSaid= '  + '' + ISNULL(@V_NEW_CDCTBLSAIDEN,'')+' '+
                                  'CdEncargoNFE= ' + '' + ISNULL(@V_OLD_CDENCARGONFE, '');
         END;

         IF NOT @V_NEW_IDENCARGO IS NULL BEGIN
            SET @V_DESC = @V_DESC + ' idencargo= ' + @V_NEW_IDENCARGO;
         END;
      END;
      SET @V_DESC = SUBSTRING(@V_DESC, 1, 300);

      IF @V_IDTIPOOPER <> '' BEGIN

         INSERT INTO LOGOPERA
            (NMTABELA,        DTOPERACAO,         NMRESPOPER,
             IDTIPOOPER,      DSOPERACAO,         CDPESQITEM,
             DSRDMUSUOPER,    DSENDUSUOPER,       DSNMUSUOPER,
             DSMETUSUOPER,    CDORESPOPER)
         VALUES
            ('ENCARGO',       GETDATE(),        ISNULL(@V_NMOPERADOR,' '),
             @V_IDTIPOOPER,   @V_DESC,          @V_ITPESQ,
             @V_DSSERVERRDM,  @V_DSREMOTEADDR,  @V_DSREMOTEHOST,
             @V_DSSERVMETHOD, @V_DSREMOTEOPER);

      END;

      FETCH NEXT FROM C_CURSOR INTO @V_ID_COMANDO,
                                    @V_OLD_CDENCARGO,
                                    @V_OLD_CDENCARGONFE,
                                    @V_OLD_IDENCARGO,
                                    @V_OLD_CDCTBLENTREN,
                                    @V_OLD_CDCTBLSAIDEN,

                                    @V_NEW_CDENCARGO,
                                    @V_NEW_CDENCARGONFE,
                                    @V_NEW_IDENCARGO,
                                    @V_NEW_CDCTBLENTREN,
                                    @V_NEW_CDCTBLSAIDEN;
   END;
   CLOSE      C_CURSOR;
   DEALLOCATE C_CURSOR;
END;
GO

-- VERSAO --
EXEC ATUVEROBJ 'LOG_GER_ENCARGO','4.11.105';
GO
